program Project1;

{$mode objfpc}{$H+}

uses
  sysutils,
  fpstypes, fpspreadsheet, xlsxooxml;

const
  NUMBER1 = pi*0.1;
  NUMBER2 = pi*1000;
  NUMBER3 = pi*1000*1000;

var
  b: TsWorkbook;
  sh: TsWorksheet;
  fmtStr: String;
begin
  b := TsWorkbook.Create;
  try
    sh := b.AddWorksheet('Test');
    sh.WriteColWidth(0, 40, suMillimeters);

    sh.WriteText(0, 0, 'Use nfFixedTh');
    sh.WriteNumber(0, 1, NUMBER1, nfFixedTh, 3);    // 3 = number of decimal places
    sh.WriteNumber(0, 2, NUMBER2, nfFixedTh, 3);    // 3 = number of decimal places
    sh.WriteNumber(0, 3, NUMBER3, nfFixedTh, 3);

    fmtStr := '#,##0.000';
    sh.WriteText(1, 0, 'Use ''' + fmtStr + '''');
    sh.WriteNumber(1, 1, NUMBER1, nfCustom, fmtStr);
    sh.WriteNumber(1, 2, NUMBER2, nfCustom, fmtStr);
    sh.WriteNumber(1, 3, NUMBER3, nfCustom, fmtStr);
    WriteLn('FormatFloat(''' + fmtStr + ''') --> ', FormatFloat(fmtStr, NUMBER1),
            ' ', FormatFloat(fmtStr, NUMBER2), ' ', FormatFloat(fmtStr, NUMBER3));

    sh.WriteText(3, 0, 'These do not work as expected:');

    fmtStr := '#,###.000';
    sh.WriteText(4, 0, 'Use ''' + fmtStr + '''');
    sh.WriteNumber(4, 1, NUMBER1, nfCustom, fmtStr);
    sh.WriteNumber(4, 2, NUMBER2, nfCustom, fmtStr);
    sh.WriteNumber(4, 3, NUMBER3, nfCustom, fmtStr);
    WriteLn('FormatFloat(''' + fmtStr + ''') --> ', FormatFloat(fmtStr, NUMBER1),
            ' ', FormatFloat(fmtStr, NUMBER2), ' ', FormatFloat(fmtStr, NUMBER3));

    fmtStr := '#,##.000';
    sh.WriteText(5, 0, 'Use ''' + fmtStr + '''');
    sh.WriteNumber(5, 1, NUMBER1, nfCustom, fmtStr);
    sh.WriteNumber(5, 2, NUMBER2, nfCustom, fmtStr);
    sh.WriteNumber(5, 3, NUMBER3, nfCustom, fmtStr);
    WriteLn('FormatFloat(''' + fmtStr + ''') --> ', FormatFloat(fmtStr, NUMBER1),
            ' ', FormatFloat(fmtStr, NUMBER2), ' ', FormatFloat(fmtStr, NUMBER3));

    fmtStr := '#,###,##0.000';
    sh.WriteText(6, 0, 'Use ''' + fmtStr + '''');
    sh.WriteNumber(6, 1, NUMBER1, nfCustom, fmtStr);
    sh.WriteNumber(6, 2, NUMBER2, nfCustom, fmtStr);
    sh.WriteNumber(6, 3, NUMBER3, nfCustom, fmtStr);
    WriteLn('FormatFloat(''' + fmtStr + ''') --> ', FormatFloat(fmtStr, NUMBER1),
            ' ', FormatFloat(fmtStr, NUMBER2), ' ', FormatFloat(fmtStr, NUMBER3));

    fmtStr := ',.000';
    sh.WriteText(7, 0, 'Use ''' + fmtStr + '''');
    sh.WriteNumber(7, 1, NUMBER1, nfCustom, fmtStr);
    sh.WriteNumber(7, 2, NUMBER2, nfCustom, fmtStr);
    sh.WriteNumber(7, 3, NUMBER3, nfCustom, fmtStr);
    WriteLn('FormatFloat(''' + fmtStr + ''') --> ', FormatFloat(fmtStr, NUMBER1),
            ' ', FormatFloat(fmtStr, NUMBER2), ' ', FormatFloat(fmtStr, NUMBER3));

    b.WriteToFile('test.xlsx', true);
  finally
    b.Free;
  end;

  ReadLn;
end.

